from datetime import date

# Filter functions that a client should send to a DBM server before it can issue
# any queries!

def filter1(record):
    if record['City'] == 'San Francisco' and record['BloodType'] == 'A+':
        return record
    else:
        return None

def filter2(record):
    Birthday = record['Birthday']
    State = record['State']
    age = db_age(Birthday)
    if age>32 and State == 'FL':
        return record
    else:
        return None


def filter3(record):
    Birthday  = record['Birthday']
    Gender    = record['Gender']
    State     = record['State']
    BloodType = record['BloodType']

    age = db_age(Birthday)
    if Gender == 'female' and age<45 and (State == 'OH' or State == 'CA') and BloodType == 'B+' :
        # adding new key: 'Age' !
        record['Age'] = age
        return record
    else:
        return None

def filter4(record):
    Gender = record['Gender']
    State = record['State']
    Vehicle = record['Vehicle']
    model = Vehicle.split()[0]
    if Gender == 'male' and (State == 'OH' or State == 'FL') and (model == '2000' or model == '2003' or model == '2007') :
        return record
    else:
        return None


def filter5(record):
    Gender = record['Gender']
    Birthday = record['Birthday']
    State = record['State']
    Company = record['Company']
    Email = record['EmailAddress']
    domain = Email.split('@')[1]
    month,day,year = Birthday.split("/")
    year = int(year)
    if Gender == 'female' and domain == 'superrito.com' and Company == 'Simple Solutions' and 1978 <= year <=1992:
        return record
    else:
        return None

# You can also insert small utility functions into this file that are needed by
# the filters
# Get the age from Birthday
# Birthday = Month/Day/Year
def db_age(Birthday):
    month,day,year = [int(x) for x in Birthday.split("/")]
    birthday = date(year,month,day)
    today = date.today()
    y = today.year - birthday.year
    if today.month < birthday.month or today.month == birthday.month and today.day < birthday.day:
        y -= 1
    return y


